class
	PD_COMPILE_DATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} lcc.make
			create {CE_NATURAL_8_POINTER} fcc.make
			create {CE_NATURAL_8_POINTER} cbits.make
			create {CE_NATURAL_8_POINTER} ctypes.make
			create {CE_NATURAL_8_POINTER} start_workspace.make
			create {CE_NATURAL_8_POINTER} start_code.make
			create {CE_NATURAL_8_POINTER} start_pattern.make
			create {CE_NATURAL_8_POINTER} end_pattern.make
			create {CE_CLASS_POINTER [PD_OPEN_CAPITEM]} open_caps.make
			create {CE_NATURAL_8_POINTER} hwm.make
			create {CE_NATURAL_8_POINTER} name_table.make
			create {CE_NATURAL_8_ARRAY} nl.make (<<4>>)
		end

	make_initialized (a_data: TUPLE [
				a_lcc: CE_POINTER [NATURAL_8]
				a_fcc: CE_POINTER [NATURAL_8]
				a_cbits: CE_POINTER [NATURAL_8]
				a_ctypes: CE_POINTER [NATURAL_8]
				a_start_workspace: CE_POINTER [NATURAL_8]
				a_start_code: CE_POINTER [NATURAL_8]
				a_start_pattern: CE_POINTER [NATURAL_8]
				a_end_pattern: CE_POINTER [NATURAL_8]
				a_open_caps: CE_POINTER [PD_OPEN_CAPITEM]
				a_hwm: CE_POINTER [NATURAL_8]
				a_name_table: CE_POINTER [NATURAL_8]
				a_names_found: INTEGER_32
				a_name_entry_size: INTEGER_32
				a_workspace_size: INTEGER_32
				a_bracount: NATURAL_32
				a_final_bracount: INTEGER_32
				a_max_lookbehind: INTEGER_32
				a_top_backref: INTEGER_32
				a_backref_map: NATURAL_32
				a_assert_depth: INTEGER_32
				a_external_options: INTEGER_32
				a_external_flags: INTEGER_32
				a_req_varyopt: INTEGER_32
				a_had_accept: INTEGER_32
				a_had_pruneorskip: INTEGER_32
				a_check_lookbehind: INTEGER_32
				a_nltype: INTEGER_32
				a_nllen: INTEGER_32
				a_nl: CE_ARRAY [NATURAL_8]
			])
		do
			lcc := a_data.a_lcc
			fcc := a_data.a_fcc
			cbits := a_data.a_cbits
			ctypes := a_data.a_ctypes
			start_workspace := a_data.a_start_workspace
			start_code := a_data.a_start_code
			start_pattern := a_data.a_start_pattern
			end_pattern := a_data.a_end_pattern
			open_caps := a_data.a_open_caps
			hwm := a_data.a_hwm
			name_table := a_data.a_name_table
			names_found := a_data.a_names_found
			name_entry_size := a_data.a_name_entry_size
			workspace_size := a_data.a_workspace_size
			bracount := a_data.a_bracount
			final_bracount := a_data.a_final_bracount
			max_lookbehind := a_data.a_max_lookbehind
			top_backref := a_data.a_top_backref
			backref_map := a_data.a_backref_map
			assert_depth := a_data.a_assert_depth
			external_options := a_data.a_external_options
			external_flags := a_data.a_external_flags
			req_varyopt := a_data.a_req_varyopt
			had_accept := a_data.a_had_accept
			had_pruneorskip := a_data.a_had_pruneorskip
			check_lookbehind := a_data.a_check_lookbehind
			nltype := a_data.a_nltype
			nllen := a_data.a_nllen
			nl := a_data.a_nl
		end

feature {ANY} -- fields

	lcc: CE_POINTER [NATURAL_8] assign set__lcc

	fcc: CE_POINTER [NATURAL_8] assign set__fcc

	cbits: CE_POINTER [NATURAL_8] assign set__cbits

	ctypes: CE_POINTER [NATURAL_8] assign set__ctypes

	start_workspace: CE_POINTER [NATURAL_8] assign set__start_workspace

	start_code: CE_POINTER [NATURAL_8] assign set__start_code

	start_pattern: CE_POINTER [NATURAL_8] assign set__start_pattern

	end_pattern: CE_POINTER [NATURAL_8] assign set__end_pattern

	open_caps: CE_POINTER [PD_OPEN_CAPITEM] assign set__open_caps

	hwm: CE_POINTER [NATURAL_8] assign set__hwm

	name_table: CE_POINTER [NATURAL_8] assign set__name_table

	names_found: INTEGER_32 assign set__names_found

	name_entry_size: INTEGER_32 assign set__name_entry_size

	workspace_size: INTEGER_32 assign set__workspace_size

	bracount: NATURAL_32 assign set__bracount

	final_bracount: INTEGER_32 assign set__final_bracount

	max_lookbehind: INTEGER_32 assign set__max_lookbehind

	top_backref: INTEGER_32 assign set__top_backref

	backref_map: NATURAL_32 assign set__backref_map

	assert_depth: INTEGER_32 assign set__assert_depth

	external_options: INTEGER_32 assign set__external_options

	external_flags: INTEGER_32 assign set__external_flags

	req_varyopt: INTEGER_32 assign set__req_varyopt

	had_accept: INTEGER_32 assign set__had_accept

	had_pruneorskip: INTEGER_32 assign set__had_pruneorskip

	check_lookbehind: INTEGER_32 assign set__check_lookbehind

	nltype: INTEGER_32 assign set__nltype

	nllen: INTEGER_32 assign set__nllen

	nl: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set__lcc (a_lcc: CE_POINTER [NATURAL_8])
		do
			lcc := a_lcc
			update_memory_field ("lcc")
		end

	set__fcc (a_fcc: CE_POINTER [NATURAL_8])
		do
			fcc := a_fcc
			update_memory_field ("fcc")
		end

	set__cbits (a_cbits: CE_POINTER [NATURAL_8])
		do
			cbits := a_cbits
			update_memory_field ("cbits")
		end

	set__ctypes (a_ctypes: CE_POINTER [NATURAL_8])
		do
			ctypes := a_ctypes
			update_memory_field ("ctypes")
		end

	set__start_workspace (a_start_workspace: CE_POINTER [NATURAL_8])
		do
			start_workspace := a_start_workspace
			update_memory_field ("start_workspace")
		end

	set__start_code (a_start_code: CE_POINTER [NATURAL_8])
		do
			start_code := a_start_code
			update_memory_field ("start_code")
		end

	set__start_pattern (a_start_pattern: CE_POINTER [NATURAL_8])
		do
			start_pattern := a_start_pattern
			update_memory_field ("start_pattern")
		end

	set__end_pattern (a_end_pattern: CE_POINTER [NATURAL_8])
		do
			end_pattern := a_end_pattern
			update_memory_field ("end_pattern")
		end

	set__open_caps (a_open_caps: CE_POINTER [PD_OPEN_CAPITEM])
		do
			open_caps := a_open_caps
			update_memory_field ("open_caps")
		end

	set__hwm (a_hwm: CE_POINTER [NATURAL_8])
		do
			hwm := a_hwm
			update_memory_field ("hwm")
		end

	set__name_table (a_name_table: CE_POINTER [NATURAL_8])
		do
			name_table := a_name_table
			update_memory_field ("name_table")
		end

	set__names_found (a_names_found: INTEGER_32)
		do
			names_found := a_names_found
			update_memory_field ("names_found")
		end

	set__name_entry_size (a_name_entry_size: INTEGER_32)
		do
			name_entry_size := a_name_entry_size
			update_memory_field ("name_entry_size")
		end

	set__workspace_size (a_workspace_size: INTEGER_32)
		do
			workspace_size := a_workspace_size
			update_memory_field ("workspace_size")
		end

	set__bracount (a_bracount: NATURAL_32)
		do
			bracount := a_bracount
			update_memory_field ("bracount")
		end

	set__final_bracount (a_final_bracount: INTEGER_32)
		do
			final_bracount := a_final_bracount
			update_memory_field ("final_bracount")
		end

	set__max_lookbehind (a_max_lookbehind: INTEGER_32)
		do
			max_lookbehind := a_max_lookbehind
			update_memory_field ("max_lookbehind")
		end

	set__top_backref (a_top_backref: INTEGER_32)
		do
			top_backref := a_top_backref
			update_memory_field ("top_backref")
		end

	set__backref_map (a_backref_map: NATURAL_32)
		do
			backref_map := a_backref_map
			update_memory_field ("backref_map")
		end

	set__assert_depth (a_assert_depth: INTEGER_32)
		do
			assert_depth := a_assert_depth
			update_memory_field ("assert_depth")
		end

	set__external_options (a_external_options: INTEGER_32)
		do
			external_options := a_external_options
			update_memory_field ("external_options")
		end

	set__external_flags (a_external_flags: INTEGER_32)
		do
			external_flags := a_external_flags
			update_memory_field ("external_flags")
		end

	set__req_varyopt (a_req_varyopt: INTEGER_32)
		do
			req_varyopt := a_req_varyopt
			update_memory_field ("req_varyopt")
		end

	set__had_accept (a_had_accept: INTEGER_32)
		do
			had_accept := a_had_accept
			update_memory_field ("had_accept")
		end

	set__had_pruneorskip (a_had_pruneorskip: INTEGER_32)
		do
			had_pruneorskip := a_had_pruneorskip
			update_memory_field ("had_pruneorskip")
		end

	set__check_lookbehind (a_check_lookbehind: INTEGER_32)
		do
			check_lookbehind := a_check_lookbehind
			update_memory_field ("check_lookbehind")
		end

	set__nltype (a_nltype: INTEGER_32)
		do
			nltype := a_nltype
			update_memory_field ("nltype")
		end

	set__nllen (a_nllen: INTEGER_32)
		do
			nllen := a_nllen
			update_memory_field ("nllen")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lcc := a_other.lcc
			fcc := a_other.fcc
			cbits := a_other.cbits
			ctypes := a_other.ctypes
			start_workspace := a_other.start_workspace
			start_code := a_other.start_code
			start_pattern := a_other.start_pattern
			end_pattern := a_other.end_pattern
			open_caps := a_other.open_caps
			hwm := a_other.hwm
			name_table := a_other.name_table
			names_found := a_other.names_found
			name_entry_size := a_other.name_entry_size
			workspace_size := a_other.workspace_size
			bracount := a_other.bracount
			final_bracount := a_other.final_bracount
			max_lookbehind := a_other.max_lookbehind
			top_backref := a_other.top_backref
			backref_map := a_other.backref_map
			assert_depth := a_other.assert_depth
			external_options := a_other.external_options
			external_flags := a_other.external_flags
			req_varyopt := a_other.req_varyopt
			had_accept := a_other.had_accept
			had_pruneorskip := a_other.had_pruneorskip
			check_lookbehind := a_other.check_lookbehind
			nltype := a_other.nltype
			nllen := a_other.nllen
			nl := a_other.nl.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lcc.is_equal (a_other.lcc) and
				fcc.is_equal (a_other.fcc) and
				cbits.is_equal (a_other.cbits) and
				ctypes.is_equal (a_other.ctypes) and
				start_workspace.is_equal (a_other.start_workspace) and
				start_code.is_equal (a_other.start_code) and
				start_pattern.is_equal (a_other.start_pattern) and
				end_pattern.is_equal (a_other.end_pattern) and
				open_caps.is_equal (a_other.open_caps) and
				hwm.is_equal (a_other.hwm) and
				name_table.is_equal (a_other.name_table) and
				names_found = a_other.names_found and
				name_entry_size = a_other.name_entry_size and
				workspace_size = a_other.workspace_size and
				bracount = a_other.bracount and
				final_bracount = a_other.final_bracount and
				max_lookbehind = a_other.max_lookbehind and
				top_backref = a_other.top_backref and
				backref_map = a_other.backref_map and
				assert_depth = a_other.assert_depth and
				external_options = a_other.external_options and
				external_flags = a_other.external_flags and
				req_varyopt = a_other.req_varyopt and
				had_accept = a_other.had_accept and
				had_pruneorskip = a_other.had_pruneorskip and
				check_lookbehind = a_other.check_lookbehind and
				nltype = a_other.nltype and
				nllen = a_other.nllen and
				nl.is_equal (a_other.nl)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lcc"),
					create {CE_STRUCTURE_FIELD}.make ("fcc"),
					create {CE_STRUCTURE_FIELD}.make ("cbits"),
					create {CE_STRUCTURE_FIELD}.make ("ctypes"),
					create {CE_STRUCTURE_FIELD}.make ("start_workspace"),
					create {CE_STRUCTURE_FIELD}.make ("start_code"),
					create {CE_STRUCTURE_FIELD}.make ("start_pattern"),
					create {CE_STRUCTURE_FIELD}.make ("end_pattern"),
					create {CE_STRUCTURE_FIELD}.make ("open_caps"),
					create {CE_STRUCTURE_FIELD}.make ("hwm"),
					create {CE_STRUCTURE_FIELD}.make ("name_table"),
					create {CE_STRUCTURE_FIELD}.make ("names_found"),
					create {CE_STRUCTURE_FIELD}.make ("name_entry_size"),
					create {CE_STRUCTURE_FIELD}.make ("workspace_size"),
					create {CE_STRUCTURE_FIELD}.make ("bracount"),
					create {CE_STRUCTURE_FIELD}.make ("final_bracount"),
					create {CE_STRUCTURE_FIELD}.make ("max_lookbehind"),
					create {CE_STRUCTURE_FIELD}.make ("top_backref"),
					create {CE_STRUCTURE_FIELD}.make ("backref_map"),
					create {CE_STRUCTURE_FIELD}.make ("assert_depth"),
					create {CE_STRUCTURE_FIELD}.make ("external_options"),
					create {CE_STRUCTURE_FIELD}.make ("external_flags"),
					create {CE_STRUCTURE_FIELD}.make ("req_varyopt"),
					create {CE_STRUCTURE_FIELD}.make ("had_accept"),
					create {CE_STRUCTURE_FIELD}.make ("had_pruneorskip"),
					create {CE_STRUCTURE_FIELD}.make ("check_lookbehind"),
					create {CE_STRUCTURE_FIELD}.make ("nltype"),
					create {CE_STRUCTURE_FIELD}.make ("nllen"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("nl", <<4>>)
				>>)
			init_structure_info
		end

end
