class
	PD_PCRE_STUDY_DATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_ARRAY} start_bits.make (<<32>>)
		end

	make_initialized (a_data: TUPLE [
				a_size: NATURAL_32
				a_flags: NATURAL_32
				a_start_bits: CE_ARRAY [NATURAL_8]
				a_minlength: NATURAL_32
			])
		do
			size := a_data.a_size
			flags := a_data.a_flags
			start_bits := a_data.a_start_bits
			minlength := a_data.a_minlength
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set__size

	flags: NATURAL_32 assign set__flags

	start_bits: CE_ARRAY [NATURAL_8]

	minlength: NATURAL_32 assign set__minlength

feature {ANY} -- field setters

	set__size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set__flags (a_flags: NATURAL_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set__minlength (a_minlength: NATURAL_32)
		do
			minlength := a_minlength
			update_memory_field ("minlength")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			flags := a_other.flags
			start_bits := a_other.start_bits.twin
			minlength := a_other.minlength
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				flags = a_other.flags and
				start_bits.is_equal (a_other.start_bits) and
				minlength = a_other.minlength
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("start_bits", <<32>>),
					create {CE_STRUCTURE_FIELD}.make ("minlength")
				>>)
			init_structure_info
		end

end
