class
	PD_UCD_RECORD

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make_initialized (a_data: TUPLE [
				a_script: NATURAL_8
				a_chartype: NATURAL_8
				a_gbprop: NATURAL_8
				a_caseset: NATURAL_8
				a_other_case: INTEGER_32
			])
		do
			script := a_data.a_script
			chartype := a_data.a_chartype
			gbprop := a_data.a_gbprop
			caseset := a_data.a_caseset
			other_case := a_data.a_other_case
		end

feature {ANY} -- fields

	script: NATURAL_8 assign set__script

	chartype: NATURAL_8 assign set__chartype

	gbprop: NATURAL_8 assign set__gbprop

	caseset: NATURAL_8 assign set__caseset

	other_case: INTEGER_32 assign set__other_case

feature {ANY} -- field setters

	set__script (a_script: NATURAL_8)
		do
			script := a_script
			update_memory_field ("script")
		end

	set__chartype (a_chartype: NATURAL_8)
		do
			chartype := a_chartype
			update_memory_field ("chartype")
		end

	set__gbprop (a_gbprop: NATURAL_8)
		do
			gbprop := a_gbprop
			update_memory_field ("gbprop")
		end

	set__caseset (a_caseset: NATURAL_8)
		do
			caseset := a_caseset
			update_memory_field ("caseset")
		end

	set__other_case (a_other_case: INTEGER_32)
		do
			other_case := a_other_case
			update_memory_field ("other_case")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			script := a_other.script
			chartype := a_other.chartype
			gbprop := a_other.gbprop
			caseset := a_other.caseset
			other_case := a_other.other_case
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				script = a_other.script and
				chartype = a_other.chartype and
				gbprop = a_other.gbprop and
				caseset = a_other.caseset and
				other_case = a_other.other_case
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("script"),
					create {CE_STRUCTURE_FIELD}.make ("chartype"),
					create {CE_STRUCTURE_FIELD}.make ("gbprop"),
					create {CE_STRUCTURE_FIELD}.make ("caseset"),
					create {CE_STRUCTURE_FIELD}.make ("other_case")
				>>)
			init_structure_info
		end

end
