class
	S_STRING_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	memcpy (a_dest, a_src: CE_POINTER [ANY]; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			a_dest.c_pointer.memory_copy (a_src.c_pointer, a_n.to_integer_32)
			Result := a_dest
		end

	memmove (a_dest, a_src: CE_POINTER [ANY]; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			a_dest.c_pointer.memory_move (a_src.c_pointer, a_n.to_integer_32)
			Result := a_dest
		end

	memset (a_s: CE_POINTER [ANY]; a_c: INTEGER_32; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			a_s.c_pointer.memory_set (a_c, a_n.to_integer_32)
			Result := a_s
		end

	memcmp (a_s1, a_s2: CE_POINTER [ANY]; a_n: NATURAL_32): BOOLEAN
		do
			Result := a_s1.c_pointer.memory_compare (a_s2.c_pointer, a_n.to_integer_32)
		end

	strncmp (a_s1, a_s2: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): INTEGER_32
		local
			l_n, l_i: INTEGER_32
		do
			from
				l_n := a_n.to_integer_32
			until
				l_i + 1 > l_n
			loop
				Result := a_s1[l_i].three_way_comparison (a_s2[l_i])
				if Result = 0 and a_s1[l_i] /= 0 then
					l_i := l_i + 1
				else
					l_i := l_n -- done
				end
			end
		end

	strlen (a_s: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			from
			until
				a_s[Result.to_integer_32] = 0
			loop
				Result := Result + 1
			end
		end

	strcmp (a_s1, a_s2: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: INTEGER_32
		do
			from
			until
				l_i = -1
			loop
				Result := a_s1[l_i].three_way_comparison (a_s2[l_i])
				if Result = 0 and a_s1[l_i] /= 0 then
					l_i := l_i + 1
				else
					l_i := -1 -- done
				end
			end
		end

end
